标签:线段树
Just a Hook
Time Limit: 4000/2000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 23147 Accepted Submission(s): 11604
Problem Description
In the game of DotA, Pudge’s meat hook is actually the most horrible thing for most of the heroes. The hook is made up of several consecutive metallic sticks which are of the same length.
Now Pudge wants to do some operations on the hook.
Let us number the consecutive metallic sticks of the hook from 1 to N. For each operation, Pudge can change the consecutive metallic sticks, numbered from X to Y, into cupreous sticks, silver sticks or golden sticks.
The total value of the hook is calculated as the sum of values of N metallic sticks. More precisely, the value for each kind of stick is calculated as follows:
For each cupreous stick, the value is 1.
For each silver stick, the value is 2.
For each golden stick, the value is 3.
Pudge wants to know the total value of the hook after performing the operations.
You may consider the original hook is made up of cupreous sticks.
Input
The input consists of several test cases. The first line of the input is the number of the cases. There are no more than 10 cases.
For each case, the first line contains an integer N, 1<=N<=100,000, which is the number of the sticks of Pudge’s meat hook and the second line contains an integer Q, 0<=Q<=100,000, which is the number of the operations.
Next Q lines, each line contains three integers X, Y, 1<=X<=Y<=N, Z, 1<=Z<=3, which defines an operation: change the sticks numbered from X to Y into the metal kind Z, where Z=1 represents the cupreous kind, Z=2 represents the silver kind and Z=3 represents
the golden kind.
Output
For each case, print a number in a line representing the total value of the hook after the operations. Use the format in the example.
Sample Input
Sample Output
Case 1: The total value of the hook is 24.
Source
Recommend
wangye
题目意思是说,给定一个数N,表示区间1~N,区间初始元素全部为1,然后输入x,y,z ,表示从区间x到y间元素变为z,操作后,对总区间求和.
就是简单的区间更新,套模板就好了。
#include <algorithm>
#include <iostream>
#include <cstdio>
#include <cstring>
using namespace std;
#define lson l,m,rt<<1
#define rson m+1,r,(rt<<1)|1
#define root 1,n,1
#define mid (l+r)>>1
#define LL long long
const int MX = 100000 + 10;
int k;
LL add[MX*4];
LL sum[MX*4];
void pushup(int rt) {
sum[rt]=sum[rt<<1]+sum[rt<<1|1];
}
void build(int l,int r,int rt) {
add[rt]=0;
if(l==r) {
//scanf("%lld",&sum[rt]);
sum[rt]=1;
return ;
}
int m=mid;
build(lson);
build(rson);
pushup(rt);
}
void pushdown(int rt,int m) {
if(add[rt]) {
add[rt<<1]=add[rt];
add[rt<<1|1]=add[rt];
sum[rt<<1]=add[rt]*(m-(m>>1));
sum[rt<<1|1]=add[rt]*(m>>1);
add[rt]=0;
}
}
void update(int L,int R,LL c,int l,int r,int rt) {
if(L<=l && r<=R) {
add[rt]=c;
sum[rt]=c*(r-l+1);
return ;
}
pushdown(rt,r-l+1);
int m=mid;
if(L<=m)update(L,R,c,lson);
if(R>m) update(L,R,c,rson);
pushup(rt);
}
LL query(int L,int R,int l,int r,int rt) {
if(L<=l && r<=R)
return sum[rt];
pushdown(rt,r-l+1);
int m=mid;
LL ret=0;
if(L<=m)ret+=query(L,R,lson);
if(R>m) ret+=query(L,R,rson);
return ret;
}
int main() {
int t,n,q,x,y,z,cas=1;
scanf("%d",&t);
while(t--) {
scanf("%d%d",&n,&q);
build(root);
while(q--) {
scanf("%d%d%d",&x,&y,&z);
update(x,y,z,root);
}
printf("Case %d: The total value of the hook is %lld.\n",cas++,query(1,n,root));
}
return 0;
}
这道题,由于最后求的是区间总和,所以不用线段树也可以做。
#include <cstdio>
const int MX = 100000+10;
int num[MX][3];
int main() {
int t,q,n,sum,val,cas=1;
scanf("%d",&t);
while(t--) {
scanf("%d%d",&n,&q);
for(int j=1; j<=q; j++)
scanf("%d%d%d",&num[j][0],&num[j][1],&num[j][2]);
sum=0;
for(int k=1; k<=n; k++) {
val=1;
for(int j=q; j>=1; j--)
if(num[j][0]<=k && k<=num[j][1]) { //寻找k所在的更新区间,若存在则更新,不存在v=1不变
val=num[j][2]; //若找的最后面的更新区间,则停止,因为前面的会被覆盖
break;
}
sum+=val;
}
printf("Case %d: The total value of the hook is %d.\n",cas++,sum);
}
return 0;
}
上述代码的大概思路是:判断每个点是否在某更新区间,在则更新,不在不处理,因为前面的会被后面的覆盖,所以我们从后面考虑,倒着做。
版权声明:本文为博主原创文章,未经博主允许不得转载。
HDU 1698 Just a Hook
标签:线段树
原文地址:http://blog.csdn.net/zhang_xueping/article/details/48002335